<template>
  <div id="discover" >
    <van-pull-refresh v-model="isReloadingDiscover" @refresh="refreshDiscover" id="content" v-if="!searching" >
      <div class="item-container" v-for="(item,index) in items" :key="index" >
        <div v-if="item.type==='user'" class="item-user">
          <div class="reason">{{item.data.reason}}</div>
          <div class="basic-info">
            <div @click="onTapUser(item.data.user.userId)" style="display: flex;flex-direction: row;flex:1;">
              <el-avatar class="avatar" :src="item.data.user.profilePhotoUrl"/>
              <div class="text-info">
                <span class="nick-name">{{item.data.user.name}}</span>
                <span class="motor">{{item.data.user.introduction}}</span>
              </div>
            </div>
            <button class="button" @click="switchFollow(index)"><i class="icon follow-icon"/>{{item.data.user.followed?'已关注':'关 注'}}</button>
          </div>
          <div class="edu-tags">
            <div v-for="tag in item.data.user.educationTags" :key="tag" class="tag">
              {{tag}}
            </div>
          </div>
          <div class="hobby-tags">
            <div v-for="tag in item.data.user.tag" :key="tag" class="tag">
              {{tag}}
            </div>
          </div>
        </div>
        <div v-else class="item-activity">
          <div class="title" @click="onTapBoard(item.data.id)">{{item.data.title}}</div>
          <el-image alt="" class="content-image" :fit="'cover'" @click="onTapBoard(item.data.id)"
                    v-if="item.data.related_image.length>0" :src="item.data.related_image[0]"/>
          <div class="content" @click="onTapBoard(item.data.id)">{{item.data.content}}</div>
          <div class="footnote">
            <span class="footnote-info">
              <!-- {{item.data.userCount}}人参加&nbsp;&nbsp; -->
              <!--              {{item.data.visitNum}}次浏览-->
            </span>
            <button class="button" @click="switchCollect(index)"><i class="icon"></i>{{item.data.followed?'已收藏':'收藏'}}</button>
          </div>
        </div>
      </div>
    </van-pull-refresh>
    <van-pull-refresh v-model="isReloadingSearch" @refresh="doSearch" id="result" v-else>
      <div class="item-container" v-for="(item,index) in searchResult" :key="index" >
        <div v-if="item.type==='user'" class="item-user">
          <div class="reason"></div>
          <div class="basic-info">
            <div @click="onTapUser(item.data.user.userId)" style="display: flex;flex-direction: row;flex:1;">
              <el-avatar class="avatar" :src="item.data.user.profilePhotoUrl"/>
              <div class="text-info">
                <span class="nick-name">{{item.data.user.name}}</span>
                <span class="motor">{{item.data.user.introduction}}</span>
              </div>
            </div>
          </div>
          <div class="edu-tags">
            <div v-for="tag in item.data.user.educationTags" :key="tag" class="tag">
              {{tag}}
            </div>
          </div>
          <div class="hobby-tags">
            <div v-for="tag in item.data.user.tag" :key="tag" class="tag">
              {{tag}}
            </div>
          </div>
        </div>
        <div v-else class="item-activity">
          <div class="title" @click="onTapBoard(item.data.id)">{{item.data.title}}</div>
          <el-image alt="" class="content-image" :fit="'cover'" @click="onTapBoard(item.data.id)" v-if="item.data.related_image.length>0" :src="item.data.related_image[0]" />
          <div class="content" @click="onTapBoard(item.data.id)">{{item.data.content}}</div>
          <div class="footnote">
            <span class="footnote-info">
              <!-- {{item.data.userCount}}人参加&nbsp;&nbsp; -->
              <!--              {{item.data.visitNum}}次浏览-->
            </span>
          </div>
        </div>
      </div>
    </van-pull-refresh>
    <div id="search-bar">
      <el-avatar :size="27" class="avatar" :src="userInfo?userInfo.profilePhotoUrl:''"/>
      <el-input v-model="keyWord" class="input-wrapper" placeholder="查找用户/图板/你可能感兴趣的内容..."
                @focus="searching=true" @change="doSearch">
        <i v-if="!searching" slot="suffix" class="icon search-icon"/>
        <i v-else slot="suffix" class="icon el-icon-close" style="line-height: 100%" @click="cancelSearch"/>
      </el-input>
    </div>
  </div>
</template>

<script>
import Vue from 'vue'
import { PullRefresh } from 'vant'
Vue.use(PullRefresh)
export default {
  name: 'Discover',
  data () {
    return {
      items: [ ],
      searching: false,
      keyWord: '',
      searchResult: [ ],
      isReloadingDiscover: false,
      isReloadingSearch: false
    }
  },
  computed: {
    userInfo () {
      return this.$store.state.userInfo.detail
    }
  },
  methods: {
    onTapBoard (id) {
      this.$router.push(`/boardDetail?id=${id}`)
    },
    switchFollow (index) {
      if (this.userInfo == null) {
        this.$message.info('请先登录')
        return
      }
      if (this.items[index].data.user.followed) {
        this.items[index].data.user.followed = false
        this.$api.unfollow(this.items[index].data.user.userId)
          .then(res => {
            this.$message.success('取关成功！')
            this.items[index].data.user.followed = false
          })
      } else {
        this.$api.follow(this.items[index].data.user.userId)
          .then(res => {
            this.$message.success('关注成功！')
            this.items[index].data.user.followed = true
          })
      }
    },
    onTapUser (id) {
      this.$router.push({
        path: '/user',
        query: {
          userId: id
        }
      })
    },
    doSearch () {
      let keyWord = this.keyWord
      this.$api.search(keyWord)
        .then(res => {
          // console.log(res)
          let data = res.data.data
          let list = []
          for (let userItem of data[0].user) {
            list.push({
              type: 'user',
              data: {
                reason: '向你推荐',
                user: { ...userItem, followed: false }
              }
            })
          }
          for (let boardItem of data[1].board) {
            let item = {
              type: 'activity',
              data: { ...boardItem, followed: false }
            }
            if (item.data.related_image != null) item.data.related_image = JSON.parse(item.data.related_image)
            else item.data.related_image = []
            list.push(item)
          }
          list.sort((a, b) => {
            return 0.5 - Math.random()
          })
          console.log(list)
          this.searchResult = list
        })
        .finally(_ => {
          this.isReloadingSearch = false
        })
    },
    cancelSearch () {
      this.searching = false
      this.keyWord = ''
    },
    switchCollect (index) {
      if (this.userInfo == null) {
        this.$message.info('请先登录')
        return
      }
      if (this.items[index].data.followed) {
        this.$api.uncollect(this.items[index].data.id)
          .then(res => {
            this.$message.success('取消收藏成功！')
            this.items[index].data.followed = false
          })
      } else {
        this.$api.collect(this.items[index].data.id, this.userInfo.userId)
          .then(res => {
            this.$message.success('收藏成功！')
            this.items[index].data.followed = true
          })
      }
    },
    refreshDiscover () {
      let id = this.userInfo ? this.userInfo.userId : ''
      this.$api.discover(id)
        .then(res => {
          // console.log(res)
          let data = res.data.data
          let list = []
          for (let userItem of data[0].users) {
            list.push({
              type: 'user',
              data: {
                reason: '向你推荐',
                user: { ...userItem, followed: false }
              }
            })
          }
          for (let boardItem of data[1].board) {
            let item = {
              type: 'activity',
              data: { ...boardItem, followed: false }
            }
            if (item.data.related_image != null) item.data.related_image = JSON.parse(item.data.related_image)
            else item.data.related_image = []
            list.push(item)
          }
          list.sort((a, b) => {
            return 0.5 - Math.random()
          })
          this.items = list
        })
        .finally(_ => {
          this.isReloadingDiscover = false
        })
    }
  },
  mounted () {
    this.userInfo = this.$store.userInfo ? this.$store.userInfo.userId : ''
    this.$api.discover(this.userInfo.userId)
      .then(res => {
        // console.log(res)
        let data = res.data.data
        let list = []
        for (let userItem of data[0].users) {
          list.push({
            type: 'user',
            data: {
              reason: '向你推荐',
              user: { ...userItem, followed: false }
            }
          })
        }
        for (let boardItem of data[1].board) {
          let item = {
            type: 'activity',
            data: { ...boardItem, followed: false }
          }
          // console.log(item.data.related_image)
          if (item.data.related_image != null) item.data.related_image = JSON.parse(item.data.related_image)
          else item.data.related_image = []
          list.push(item)
        }
        list.sort((a, b) => {
          return 0.5 - Math.random()
        })
        this.items = list
      })
  }
}
</script>

<style lang="less">
  #discover {
    min-height:100vh;
    background: #f7f7f7;
    #search-bar {
      position: fixed;
      top: 0;
      left: 0;
      right: 0;
      height: 27.52px;
      padding: 15px 11.25px;
      background-color: white;
      display: flex;
      flex-direction: row;
      align-items: center;
      justify-content: space-between;

      .avatar {
        border: 1px solid #7D7D7D;
      }

      .input-wrapper {
        height: 27.52px;
        margin-inline-start: 12px;

        input.el-input__inner {
          height: 27.52px;
          background-color: #EEEEEE;
          border: none;
          flex-grow: 1;
          font-size: 11.5px;

          &::placeholder {
            color: #9A9A9A;
          }
        }

        .icon {
          display: block;
          height: 15px;
          width: 15px;
          background-repeat: no-repeat;
          background-size: contain;
          margin: 6.26px 7.5px;
          &.search-icon {
            background-image: url("../assets/public/search_icon.png");
          }
        }
      }
    }
    #content, #result {
    //   min-height: 100vh;
      padding-block-start: 72px;
      padding-block-end: calc(10px + var(--tab-bar-height));
      background-color: transparent;
      .item-container {
        margin-block-end: 15px;
        background-color: white;
        .item-user {
          padding: 10px 25px 20px 25px;
          display: flex;
          flex-direction: column;
          .reason {
            font-size: 9px;
            color: #AAAAAA;
            margin-block-end: 15px;
          }
          .basic-info {
            display: flex;
            flex-direction: row;
            align-items: center;
            .avatar {
              width: 49px;
              height: 49px;
              margin-inline-end: 12px;
            }
            .text-info {
              flex-grow: 1;
              display: flex;
              flex-direction: column;
              .nick-name {
                margin-block-start: 3px;
                margin-block-end: 5px;
                font-size: 15px;
                font-weight: bold;
                color: #3D3D3D;
              }
              .motor {
                font-size: 9px;
                color: #7C7C7C;
              }
            }
            .button {
              width: 75px;
              height: 25px;
              border-radius: 0;
              color: #717171;
              display: flex;
              flex-direction: row;
              align-items: center;
              justify-content: center;
              background-color: white;
              border: solid 1px #BFBFBF;
              font-size: 12px;
              .icon {
                display: inline-block;
                width: 16px;
                height: 16px;
                background-repeat: no-repeat;
                background-size: contain;
                margin-inline-end: 3px;
                &.follow-icon {
                  background-image: url("../assets/discover/follow_icon.png");
                }
              }
            }
            .button:hover, .button:active {
              background-color: white;
              border: solid 1px #BFBFBF;
            }
          }
          .edu-tags {
            margin-block-start: 15px;
            display: flex;
            flex-direction: row;
            flex-wrap: wrap;
            .tag {
              padding: 3px 6px;
              color: white;
              font-size: 12px;
              background-color: #6492CB;
              margin-inline-end: 8px;
              text-wrap: avoid;
              margin-block-end: 6.5px;
              margin-bottom: 5px;
            }
          }
          .hobby-tags {
            display: flex;
            flex-direction: row;
            flex-wrap: wrap;
            .tag {
              padding: 3px 6px;
              color: white;
              font-size: 12px;
              background-color: #CB6464;
              margin-inline-end: 8px;
              text-wrap: avoid;
              margin-bottom: 5px;
            }
          }
        }
        .item-activity {
          padding: 16.5px 25px 12px 25px;
          display: flex;
          flex-direction: column;
          .title {
            font-size: 14px;
            font-weight: bold;
            line-height: 18px;
            margin-bottom: 10px;
          }
          .content-image {
            height: 176px;
            margin-block-end: 16.5px;
          }
          .user-info {
            margin-block-start: 14px;
            display: flex;
            flex-direction: row;
            align-items: center;
            margin-block-end: 12px;
            .avatar {
              width: 17px;
              height: 17px;
              margin-inline-end: 9.5px;
            }
            .nick-name {
              color: #696969;
              font-size: 12px;
            }
          }

          .content {
            color: #7C7C7C;
            font-size: 12px;
            margin-block-end: 10px;
          }
          .footnote {
            display: flex;
            flex-direction: row;
            align-items: center;
            .footnote-info {
              font-size: 12px;
              flex-grow: 1;
            }
            .button {
              width: 75px;
              height: 25px;
              border-radius: 0;
              color: #717171;
              display: flex;
              flex-direction: row;
              align-items: center;
              justify-content: center;
              background-color: white;
              border: solid 1px #BFBFBF;
              font-size: 12px;
              .icon {
                display: inline-block;
                width: 12px;
                height: 12px;
                background-image: url("../assets/discover/collection_icon.png");
                background-repeat: no-repeat;
                background-size: contain;
                margin-inline-end: 6px;
              }
            }
            .button:hover, .button:active {
              background-color: white;
              border: solid 1px #BFBFBF;
            }
          }
        }
      }
    }
  }
</style>
